#ifndef _AM_H_
#define _AM_H_
/* 
 * Common types that should be valid across all platforms.
 * All code will refer to these types, not the native ones!!!
 *
 */

#ifndef RENESASBOARD
typedef unsigned char uint8;
typedef signed char int8;
typedef unsigned short uint16;
typedef signed short int16;
typedef unsigned int uint32;
typedef signed int int32;
typedef unsigned long long uint64; 
typedef signed long long int64;
typedef float float32;
typedef double float64;
#else
typedef unsigned char uint8;
typedef signed char int8;
typedef unsigned short uint16;
typedef signed short int16;
typedef unsigned long uint32;
typedef signed long int32;
typedef float float32;
typedef double float64; /* NOTE: requires compiler flag */

#ifndef NDEBUG
#define NDEBUG
#endif /*NDEBUG*/
#endif /*RENESAS BOARD*/

typedef uint8 boolean;

typedef struct {
	unsigned int no0:1;
	unsigned int no1:1;
	unsigned int no2:1;
	unsigned int no3:1;
	unsigned int no4:1;
	unsigned int no5:1;
	unsigned int no6:1;
	unsigned int no7:1;
} bits8;

#define TRUE  1
#define FALSE 0

#ifndef NULL
#define NULL ((void*)0)
#endif /*NULL*/


#define SWAP(t, x, y) { t temp=x; x=y; y=temp; }

#define ISPTR(x) (((x.lv)&0x03)==0x00)

typedef uint32 SP;

union HEAP;
typedef union HEAP HEAP;
typedef HEAP STACK;

union HEAP {
	HEAP *hp;
	
	/* heap values */
/* #ifndef UNBOXED - better off just using lv everywhere when either boxed/unboxed IMHO */
	uint16 tag;
/* #endif */
	float32 fv;
	int32 lv;    /* bool, char, int */
	char str[4]; /* @NOTE str will thus be continuous across multple 'HEAP', and importantly, ENDIAN correct */	
	
	/* stack values */
	SP sp;
	uint32 pc;
};

/* @NOTE: (char*)(p+2) <=> (p+2)->str <=> p[2].str, however we don't use the 'str' form other than for compliled constants */


#define SUPPORT_STRING
#define SUPPORT_FLOAT

/* Enable string tables and debug code to stdout */
#define SUPPORT_DEBUG

/* Enable extra stats gathering */
#define INSTRUMENTATION


#ifdef NDEBUG
/* no heap/stack overflow checking, debugging, or instrumentation is possible when NDEBUG is live */
#undef SUPPORT_DEBUG
#undef INSTRUMENTATION
#endif

#endif /*_AM_H_*/

