#ifndef _SERIALISE_H_
#define _SERIALISE_H_

#include "am.h"

/*
 * Can serialise a hume structure into a byte array
 *
 * <type> := i[1|2|4|8]           , where (i)nteger of bytes precision
 *         | f[4|8]               , where (f)loat of bytes precision
 *         | c                    , where (c)har
 *         | b                    , where (b)ool
 *         | s <size>             , where (s)tring of size
 *         | t <size> <type>^size , where (t)uple of size
 *         | v <size> <type>      , where (v)ector of size
 *
 * e.g. image = v320v200v3i1 
 *
 * All data is byte aligned, therefore char/bool take one byte.
 *
 */

void serialiseFromHeap(int8 *bytes, HEAP *heap, const char *type);

HEAP *deserialiseToHeap(int8 *str, const char *type);


#endif /*_SERIALISE_H_*/